****************************************************************************
*
* Program..: LIGHTBAR.PRG
* Author...: Jeffrey J. Wilson
*            1209 Alameda Road NW
*            Albuquerque, NM  87114
*            (505) 898-6071
*            CIS # 70277,1727
* Date.....: November 5, 1986
* Version..: dBASE III Plus version 2.0x77 (12/26/85)
* Copyright: (c)1986 by Jeffrey J. Wilson
* Notes....: Lightbar menu selection demo. This demo can be incorporated into
*            programs to help alleviate the logjam created by nesting menus. 
*            It lets the user browse through all the possible choices in the
*            system on one screen instead of having to move through several 
*            levels of menus and look at the same choices over and over again. 
*              The menu module is set up so that the main options are on the 
*            left of the screen, while the choices associated with that option 
*            are displayed on the right of the screen. The user can move the 
*            light bar up and down the left of the screen, and the choices on 
*            the right will change according to which main option is high-
*            lighted.
*              At any time, the user can press return or a right or left arrow 
*            key to select the highlighted option and move the bar to the right
*            side of the menu, where he can again move the bar up or down to 
*            highlight choices. Pressing return selects that choice, and it is 
*            displayed at the bottom of the screen. If the user does not want
*            to make a choice, he can press the right or left arrow keys and
*            move back to the left side of the screen.
*              An alternative method of selecting options and choices is to 
*            simply press the number key corresponding to the option or choice
*            that is desired. That option or choice is highlighted directly.
*
*              The menus are limited to 9 options with a maximum of 9 choices
*            associated with each option, giving a total of 81 choices for the
*            menu. It would be possible to nest these menus for very large
*            applications.
*              For demo purposes, the options and choices are simply stored in
*            memvars, but it would be quite easy to use a .MEM file to store
*            them.
*              The program was developed on an NCR PC-8 (8mhz AT compatible),
*            and performance is acceptable. On a PC, it should be compiled to
*            be useful.
*
*              The author gives permission for this code to be modified and
*            used in applications freely. Any questions or comments would be
*            appreciated.
*
*              Files included with the upload:
*               LIGHTBAR.PRG 
*               CUROFF.BIN      - a binary file utility used to turn off the
*                                 cursor.
*               CURON.BIN       - used to turn the cursor back on.
*
*
****************************************************************************

* SET UP THE ENVIRONMENT...
SET ESCAPE OFF                 && ESCAPE ON MESSES UP THE INKEY() FUNCTION
SET CONSOLE OFF
SET ECHO OFF
SET INTENSITY ON               && SO THE SELECTIONS WILL BE HIGHLIGHTED

****************   THIS CODE CAN BE REPLACED BY A .MEM FILE   **************
* CREATE MENU OptIONS...
* LEFT SIDE MENU OptIONS HERE IN NUMERICAL ORDER (Opt1,Opt2, ETC)...
Opt1 = ' 1 - Add a new Record '
Opt2 = ' 2 - Print Reports    '
Opt3 = ' 3 - Edit Data        '
Opt4 = ' 4 - Utilities        '

* RIGHT SIDE ChoiceS HERE. CONSTRUCT THE MEMVAR NAME "Chc+<NUMBER>+OptION NUMBER"
* WHERE <OptION NUMBER> IS THE NUMBER OF THE LEFT SIDE MENU OptION THE Choice IS 
* RELATED TO. IE, Chc41 IS THE FOURTH Choice UNDER LEFT SIDE OptION NUMBER ONE...
Chc11 = ' 1 - Add a Wholesale Record     '
Chc21 = ' 2 - Add a Distributor Record   '
Chc31 = ' 3 - Add a Retail Record        '

Chc12 = ' 1 - Print all the Records      '
Chc22 = ' 2 - Print sum of Records       '
Chc32 = ' 3 - Print average of Records   '
Chc42 = ' 4 - Print the first Record     '
Chc52 = ' 5 - Print the last Record      '
Chc62 = ' 6 - Print the 30th Record      '
Chc72 = ' 7 - Print the 71st Record      '
Chc82 = ' 8 - Print the 85th Record      '
Chc92 = ' 9 - Print the 130th Record     '

Chc13 = ' 1 - Edit a Wholesale Record    '
Chc23 = ' 2 - Edit a Distributor Record  '
Chc33 = ' 3 - Edit a Retail Record       '
Chc43 = ' 4 - Edit a Test Record         '

Chc14 = ' 1 - Pack the database          '
Chc24 = ' 2 - Set up the printer         '
Chc34 = ' 3 - Set screen colors          '
Chc44 = ' 4 - Re-index the data files    '
***********************   END OF MENU ChoiceS   ******************************

CLEAR

* LOAD TWO BINARY FILES FOR CURSOR TOGGLE ON/OFF...
LOAD CUROFF.BIN
LOAD CURON.BIN

* NOW TURN THE CURSOR OFF...
CALL CUROFF

* INITIALIZE GENERAL MEMVARS...
Topline    = 1                 && TOP LINE OF MENU CHOICES CAN BE MOVED WITH THIS
Opt        = 1                 && OptION TO HIGHLIGHT
Sub        = STR(Opt,1)        && STRING VERSION OF Opt
Keypress   = 0                 && MEMVAR TO STORE VALUE FROM INKEY
Choice     = 0                 && NUMBER OF MENU Choice 
Itemcnt    = 0                 && NUMBER OF OptIONS ON THE MENU
Header = 'Sample Menu Title'   && TITLE OF THE MENU

* DISPLAY THE MENU...
SET COLOR TO W+/B+                                        
@ 0,0  SAY ' '+DTOC(DATE())+' '                           
@ 0,70 SAY ' '+TIME()+' '                                 
SET COLOR TO W/                                           
@ 1,0 TO 1,79 DOUBLE                                      
SET COLOR TO W+/                                          
@ 1,(80-(LEN(Header)+4))/2  SAY '  '+Header+'  '          
SET COLOR TO W/                                           
M_row = Topline
ON ERROR EXIT
DO WHILE M_row<19
  M_row = M_row + 2
  M_Sub = STR((M_row-Topline)/2,1)
  @ M_row,10 SAY Opt&M_Sub
  Itemcnt = Itemcnt+1
ENDDO
ON ERROR

* DISPLAY INSTRUCTIONS WITH GRAPHICS CHARACTERS...
Prompt = 'Use '+CHR(24)+', '+CHR(25)+', '+CHR(17)+CHR(217);
 +' or press number. <End> to quit. <F1> for help.'
@ 22,0 TO 22,79                                      
SET COLOR TO  W+/                                    
@ 22,(80-(LEN(Prompt)+4))/2 SAY '  '+Prompt+'  '     
SET COLOR TO W/                                      
                                                     
* REVERSE VIDEO ON OptION 1...
@ Topline+2,10 GET Opt1
CLEAR GETS
M_row = Topline
Chccnt = 0
ON ERROR EXIT
DO WHILE M_row<19
  M_row = M_row + 2
  M_Sub = STR((M_row-Topline)/2,1)+Sub
  @ M_row,40 SAY Chc&M_Sub
  Chccnt = Chccnt + 1
ENDDO
ON ERROR

* LOOP FOR SELECTION OF MENU OptIONS...
DO WHILE .T.    
  
  * WAIT FOR A KEY PRESS...
  Keypress = 0
  DO WHILE Keypress = 0
    Keypress = INKEY()
  ENDDO 
  
  * <End> KEY PRESSED...
  IF Keypress = 6
    EXIT
  ENDIF

  * <F1> KEY PRESSED FOR HELP...
  IF Keypress = 28
    @ 21,0 CLEAR
    SET COLOR TO W+/
    @ 21,0 SAY '  Use the up and down arrow keys to move the light bar. Pressing the Enter Key'
    @ 22,0 SAY '    selects the highlighted choice. Pressing a number key selects that choice. '
    @ 23,0 SAY '      After selection, the light bar moves to the right half of the screen. '
    @ 24,0 SAY '       The left and right arrow keys return to the left side of the menu.'
    WAIT
    @ 21,0 CLEAR
    @ 22,0 TO 22,79                                      
    SET COLOR TO  W+/                                    
    @ 22,(80-(LEN(Prompt)+4))/2 SAY '  '+Prompt+'  '     
    SET COLOR TO W/                                      
    @ 23,0 SAY ''                                        
  ENDIF

  * UP OR DOWN ARROW KEY PRESSED...
  IF Keypress = 24 .OR. Keypress = 5
    @ Opt*2+Topline,10 SAY Opt&Sub
    Opt = IIF(Keypress=24,Opt+1,Opt-1)
    Opt = IIF(Opt>Itemcnt,1,Opt)
    Opt = IIF(Opt<1,Itemcnt,Opt)
    Sub = STR(Opt,1)
    @ Opt*2+Topline,10 GET Opt&Sub
    CLEAR GETS
    M_row = Topline
    Chccnt = 0
    @ 3,40 CLEAR TO 21,79
    ON ERROR EXIT
    DO WHILE M_row<19
      M_row = M_row + 2
      M_Sub = STR((M_row-Topline)/2,1)+Sub
      @ M_row,40 SAY Chc&M_Sub
      Chccnt = Chccnt + 1
    ENDDO
    ON ERROR
    LOOP
  ENDIF

  * OptION NUMBER ENTERED TO SELECT AN ITEM DIRECTLY...
  IF Keypress >= 49 .AND. Keypress <= (48+Itemcnt)
    @ Opt*2+Topline,10 SAY Opt&Sub
    Opt = Keypress-48
    Sub = STR(Opt,1)
    @ Opt*2+Topline,10 GET Opt&Sub
    CLEAR GETS
    M_row = Topline
    Chccnt = 0
    ON ERROR EXIT
    DO WHILE M_row<19
      M_row = M_row + 2
      M_Sub = STR((M_row-Topline)/2,1)+Sub
      @ M_row,40 SAY Chc&M_Sub
      Chccnt = Chccnt + 1
    ENDDO
    ON ERROR
  ENDIF

  * EITHER THE RETURN KEY (13), THE LEFT/RIGHT ARROWS, OR ONE OF THE OptION
  * NUMBERS WAS PRESSED.
  * SHIFT TO THE RIGHT OF THE SCREEN AND LOOP TO CHOOSE ONE OF THE ITEMS...
  IF Keypress = 13 .OR. (Keypress >= 49 .AND. Keypress <= (48+Itemcnt)) .OR.;
   Keypress = 4 .OR. Keypress = 19
    Chc = 1
    * HIGHLIGHT Choice 1...
    M_row = Topline + 2
    M_Sub = STR((M_row-Topline)/2,1)+Sub
    @ M_row,40 GET Chc&M_Sub
    CLEAR GETS
    DO WHILE .T.
    
      * WAIT FOR A KEY PRESS...
      Keypress = 0
      DO WHILE Keypress = 0
        Keypress = INKEY()
      ENDDO  
        
      * LEFT OR RIGHT ARROW PRESSED. MOVE BACK TO LEFT SIDE OF MENU...
      IF Keypress = 4 .OR. Keypress = 19
        @ Chc*2+Topline,40 SAY Chc&M_Sub
        Choice = 0
        EXIT
      ENDIF

      * <End> KEY PRESSED...
      IF Keypress = 6
        CALL CURON
        RETURN
      ENDIF

      * UP OR DOWN ARROW KEY PRESSED...
      IF Keypress = 24 .OR. Keypress = 5
        @ Chc*2+Topline,40 SAY Chc&M_Sub
        Chc = IIF(Keypress=24,Chc+1,Chc-1)
        Chc = IIF(Chc>Chccnt,1,Chc)
        Chc = IIF(Chc<1,Chccnt,Chc)
        M_Sub = STR(Chc,1)+Sub
        @ Chc*2+Topline,40 GET Chc&M_Sub
        CLEAR GETS
        LOOP
      ENDIF

      * OPTION NUMBER ENTERED...
      IF Keypress >= 49 .AND. Keypress <= (48+Chccnt)
        @ Chc*2+Topline,40 SAY Chc&M_Sub
        Chc = Keypress-48
        M_Sub = STR(Keypress-48,1)+Sub
        Choice = Keypress-48
        @ Chc*2+Topline,40 GET Chc&M_Sub
        CLEAR GETS
        EXIT
      ENDIF

      * RETURN PRESSED...
      IF Keypress = 13
        Choice = 13
        EXIT
      ENDIF

    ENDDO  [DO WHILE .T.]
  ENDIF [Keypress = 13]

  IF Choice > 0
    @ 21,0 CLEAR
    Prompt = "Choice = "+TRIM(Chc&M_Sub)
    @ 22,0 TO 22,79                                      
    SET COLOR TO  W+/                                    
    @ 22,(80-(LEN(Prompt)+4))/2 SAY '  '+Prompt+'  '     
    SET COLOR TO W/                                      
    @ 23,0 SAY ''                                        
    EXIT
  ENDIF

ENDDO [Choice]

*TURN CURSOR BACK ON...
CALL CURON
RETURN

** [EOF LIGHTBAR.PRG]
